/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface LibraryPluginframeworkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#cluster_id LibraryPluginframework#cluster_id}
    */
    readonly clusterId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#cran LibraryPluginframework#cran}
    */
    readonly cran?: LibraryPluginframeworkCran;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#egg LibraryPluginframework#egg}
    */
    readonly egg?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#jar LibraryPluginframework#jar}
    */
    readonly jar?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#maven LibraryPluginframework#maven}
    */
    readonly maven?: LibraryPluginframeworkMaven;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#pypi LibraryPluginframework#pypi}
    */
    readonly pypi?: LibraryPluginframeworkPypi;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#requirements LibraryPluginframework#requirements}
    */
    readonly requirements?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#whl LibraryPluginframework#whl}
    */
    readonly whl?: string;
}
export interface LibraryPluginframeworkCran {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#package LibraryPluginframework#package}
    */
    readonly package: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#repo LibraryPluginframework#repo}
    */
    readonly repo?: string;
}
export declare function libraryPluginframeworkCranToTerraform(struct?: LibraryPluginframeworkCran | cdktf.IResolvable): any;
export declare function libraryPluginframeworkCranToHclTerraform(struct?: LibraryPluginframeworkCran | cdktf.IResolvable): any;
export declare class LibraryPluginframeworkCranOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LibraryPluginframeworkCran | cdktf.IResolvable | undefined;
    set internalValue(value: LibraryPluginframeworkCran | cdktf.IResolvable | undefined);
    private _package?;
    get package(): string;
    set package(value: string);
    get packageInput(): string | undefined;
    private _repo?;
    get repo(): string;
    set repo(value: string);
    resetRepo(): void;
    get repoInput(): string | undefined;
}
export interface LibraryPluginframeworkMaven {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#coordinates LibraryPluginframework#coordinates}
    */
    readonly coordinates: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#exclusions LibraryPluginframework#exclusions}
    */
    readonly exclusions?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#repo LibraryPluginframework#repo}
    */
    readonly repo?: string;
}
export declare function libraryPluginframeworkMavenToTerraform(struct?: LibraryPluginframeworkMaven | cdktf.IResolvable): any;
export declare function libraryPluginframeworkMavenToHclTerraform(struct?: LibraryPluginframeworkMaven | cdktf.IResolvable): any;
export declare class LibraryPluginframeworkMavenOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LibraryPluginframeworkMaven | cdktf.IResolvable | undefined;
    set internalValue(value: LibraryPluginframeworkMaven | cdktf.IResolvable | undefined);
    private _coordinates?;
    get coordinates(): string;
    set coordinates(value: string);
    get coordinatesInput(): string | undefined;
    private _exclusions?;
    get exclusions(): string[];
    set exclusions(value: string[]);
    resetExclusions(): void;
    get exclusionsInput(): string[] | undefined;
    private _repo?;
    get repo(): string;
    set repo(value: string);
    resetRepo(): void;
    get repoInput(): string | undefined;
}
export interface LibraryPluginframeworkPypi {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#package LibraryPluginframework#package}
    */
    readonly package: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#repo LibraryPluginframework#repo}
    */
    readonly repo?: string;
}
export declare function libraryPluginframeworkPypiToTerraform(struct?: LibraryPluginframeworkPypi | cdktf.IResolvable): any;
export declare function libraryPluginframeworkPypiToHclTerraform(struct?: LibraryPluginframeworkPypi | cdktf.IResolvable): any;
export declare class LibraryPluginframeworkPypiOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): LibraryPluginframeworkPypi | cdktf.IResolvable | undefined;
    set internalValue(value: LibraryPluginframeworkPypi | cdktf.IResolvable | undefined);
    private _package?;
    get package(): string;
    set package(value: string);
    get packageInput(): string | undefined;
    private _repo?;
    get repo(): string;
    set repo(value: string);
    resetRepo(): void;
    get repoInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework databricks_library_pluginframework}
*/
export declare class LibraryPluginframework extends cdktf.TerraformResource {
    static readonly tfResourceType = "databricks_library_pluginframework";
    /**
    * Generates CDKTF code for importing a LibraryPluginframework resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the LibraryPluginframework to import
    * @param importFromId The id of the existing LibraryPluginframework that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the LibraryPluginframework to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/library_pluginframework databricks_library_pluginframework} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options LibraryPluginframeworkConfig
    */
    constructor(scope: Construct, id: string, config: LibraryPluginframeworkConfig);
    private _clusterId?;
    get clusterId(): string;
    set clusterId(value: string);
    get clusterIdInput(): string | undefined;
    private _cran;
    get cran(): LibraryPluginframeworkCranOutputReference;
    putCran(value: LibraryPluginframeworkCran): void;
    resetCran(): void;
    get cranInput(): cdktf.IResolvable | LibraryPluginframeworkCran | undefined;
    private _egg?;
    get egg(): string;
    set egg(value: string);
    resetEgg(): void;
    get eggInput(): string | undefined;
    private _jar?;
    get jar(): string;
    set jar(value: string);
    resetJar(): void;
    get jarInput(): string | undefined;
    private _maven;
    get maven(): LibraryPluginframeworkMavenOutputReference;
    putMaven(value: LibraryPluginframeworkMaven): void;
    resetMaven(): void;
    get mavenInput(): cdktf.IResolvable | LibraryPluginframeworkMaven | undefined;
    private _pypi;
    get pypi(): LibraryPluginframeworkPypiOutputReference;
    putPypi(value: LibraryPluginframeworkPypi): void;
    resetPypi(): void;
    get pypiInput(): cdktf.IResolvable | LibraryPluginframeworkPypi | undefined;
    private _requirements?;
    get requirements(): string;
    set requirements(value: string);
    resetRequirements(): void;
    get requirementsInput(): string | undefined;
    private _whl?;
    get whl(): string;
    set whl(value: string);
    resetWhl(): void;
    get whlInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
