/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface QualityMonitorPluginframeworkConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#assets_dir QualityMonitorPluginframework#assets_dir}
    */
    readonly assetsDir: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#baseline_table_name QualityMonitorPluginframework#baseline_table_name}
    */
    readonly baselineTableName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#custom_metrics QualityMonitorPluginframework#custom_metrics}
    */
    readonly customMetrics?: QualityMonitorPluginframeworkCustomMetrics[] | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#data_classification_config QualityMonitorPluginframework#data_classification_config}
    */
    readonly dataClassificationConfig?: QualityMonitorPluginframeworkDataClassificationConfig;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#inference_log QualityMonitorPluginframework#inference_log}
    */
    readonly inferenceLog?: QualityMonitorPluginframeworkInferenceLog;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#latest_monitor_failure_msg QualityMonitorPluginframework#latest_monitor_failure_msg}
    */
    readonly latestMonitorFailureMsg?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#notifications QualityMonitorPluginframework#notifications}
    */
    readonly notifications?: QualityMonitorPluginframeworkNotifications;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#output_schema_name QualityMonitorPluginframework#output_schema_name}
    */
    readonly outputSchemaName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#schedule QualityMonitorPluginframework#schedule}
    */
    readonly schedule?: QualityMonitorPluginframeworkSchedule;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#skip_builtin_dashboard QualityMonitorPluginframework#skip_builtin_dashboard}
    */
    readonly skipBuiltinDashboard?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#slicing_exprs QualityMonitorPluginframework#slicing_exprs}
    */
    readonly slicingExprs?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#snapshot QualityMonitorPluginframework#snapshot}
    */
    readonly snapshot?: QualityMonitorPluginframeworkSnapshot;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#table_name QualityMonitorPluginframework#table_name}
    */
    readonly tableName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#time_series QualityMonitorPluginframework#time_series}
    */
    readonly timeSeries?: QualityMonitorPluginframeworkTimeSeries;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#warehouse_id QualityMonitorPluginframework#warehouse_id}
    */
    readonly warehouseId?: string;
}
export interface QualityMonitorPluginframeworkCustomMetrics {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#definition QualityMonitorPluginframework#definition}
    */
    readonly definition: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#input_columns QualityMonitorPluginframework#input_columns}
    */
    readonly inputColumns: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#name QualityMonitorPluginframework#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#output_data_type QualityMonitorPluginframework#output_data_type}
    */
    readonly outputDataType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#type QualityMonitorPluginframework#type}
    */
    readonly type: string;
}
export declare function qualityMonitorPluginframeworkCustomMetricsToTerraform(struct?: QualityMonitorPluginframeworkCustomMetrics | cdktf.IResolvable): any;
export declare function qualityMonitorPluginframeworkCustomMetricsToHclTerraform(struct?: QualityMonitorPluginframeworkCustomMetrics | cdktf.IResolvable): any;
export declare class QualityMonitorPluginframeworkCustomMetricsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): QualityMonitorPluginframeworkCustomMetrics | cdktf.IResolvable | undefined;
    set internalValue(value: QualityMonitorPluginframeworkCustomMetrics | cdktf.IResolvable | undefined);
    private _definition?;
    get definition(): string;
    set definition(value: string);
    get definitionInput(): string | undefined;
    private _inputColumns?;
    get inputColumns(): string[];
    set inputColumns(value: string[]);
    get inputColumnsInput(): string[] | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _outputDataType?;
    get outputDataType(): string;
    set outputDataType(value: string);
    get outputDataTypeInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class QualityMonitorPluginframeworkCustomMetricsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: QualityMonitorPluginframeworkCustomMetrics[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): QualityMonitorPluginframeworkCustomMetricsOutputReference;
}
export interface QualityMonitorPluginframeworkDataClassificationConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#enabled QualityMonitorPluginframework#enabled}
    */
    readonly enabled?: boolean | cdktf.IResolvable;
}
export declare function qualityMonitorPluginframeworkDataClassificationConfigToTerraform(struct?: QualityMonitorPluginframeworkDataClassificationConfig | cdktf.IResolvable): any;
export declare function qualityMonitorPluginframeworkDataClassificationConfigToHclTerraform(struct?: QualityMonitorPluginframeworkDataClassificationConfig | cdktf.IResolvable): any;
export declare class QualityMonitorPluginframeworkDataClassificationConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): QualityMonitorPluginframeworkDataClassificationConfig | cdktf.IResolvable | undefined;
    set internalValue(value: QualityMonitorPluginframeworkDataClassificationConfig | cdktf.IResolvable | undefined);
    private _enabled?;
    get enabled(): boolean | cdktf.IResolvable;
    set enabled(value: boolean | cdktf.IResolvable);
    resetEnabled(): void;
    get enabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface QualityMonitorPluginframeworkInferenceLog {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#granularities QualityMonitorPluginframework#granularities}
    */
    readonly granularities: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#label_col QualityMonitorPluginframework#label_col}
    */
    readonly labelCol?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#model_id_col QualityMonitorPluginframework#model_id_col}
    */
    readonly modelIdCol: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#prediction_col QualityMonitorPluginframework#prediction_col}
    */
    readonly predictionCol: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#prediction_proba_col QualityMonitorPluginframework#prediction_proba_col}
    */
    readonly predictionProbaCol?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#problem_type QualityMonitorPluginframework#problem_type}
    */
    readonly problemType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#timestamp_col QualityMonitorPluginframework#timestamp_col}
    */
    readonly timestampCol: string;
}
export declare function qualityMonitorPluginframeworkInferenceLogToTerraform(struct?: QualityMonitorPluginframeworkInferenceLog | cdktf.IResolvable): any;
export declare function qualityMonitorPluginframeworkInferenceLogToHclTerraform(struct?: QualityMonitorPluginframeworkInferenceLog | cdktf.IResolvable): any;
export declare class QualityMonitorPluginframeworkInferenceLogOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): QualityMonitorPluginframeworkInferenceLog | cdktf.IResolvable | undefined;
    set internalValue(value: QualityMonitorPluginframeworkInferenceLog | cdktf.IResolvable | undefined);
    private _granularities?;
    get granularities(): string[];
    set granularities(value: string[]);
    get granularitiesInput(): string[] | undefined;
    private _labelCol?;
    get labelCol(): string;
    set labelCol(value: string);
    resetLabelCol(): void;
    get labelColInput(): string | undefined;
    private _modelIdCol?;
    get modelIdCol(): string;
    set modelIdCol(value: string);
    get modelIdColInput(): string | undefined;
    private _predictionCol?;
    get predictionCol(): string;
    set predictionCol(value: string);
    get predictionColInput(): string | undefined;
    private _predictionProbaCol?;
    get predictionProbaCol(): string;
    set predictionProbaCol(value: string);
    resetPredictionProbaCol(): void;
    get predictionProbaColInput(): string | undefined;
    private _problemType?;
    get problemType(): string;
    set problemType(value: string);
    get problemTypeInput(): string | undefined;
    private _timestampCol?;
    get timestampCol(): string;
    set timestampCol(value: string);
    get timestampColInput(): string | undefined;
}
export interface QualityMonitorPluginframeworkNotificationsOnFailure {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#email_addresses QualityMonitorPluginframework#email_addresses}
    */
    readonly emailAddresses?: string[];
}
export declare function qualityMonitorPluginframeworkNotificationsOnFailureToTerraform(struct?: QualityMonitorPluginframeworkNotificationsOnFailure | cdktf.IResolvable): any;
export declare function qualityMonitorPluginframeworkNotificationsOnFailureToHclTerraform(struct?: QualityMonitorPluginframeworkNotificationsOnFailure | cdktf.IResolvable): any;
export declare class QualityMonitorPluginframeworkNotificationsOnFailureOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): QualityMonitorPluginframeworkNotificationsOnFailure | cdktf.IResolvable | undefined;
    set internalValue(value: QualityMonitorPluginframeworkNotificationsOnFailure | cdktf.IResolvable | undefined);
    private _emailAddresses?;
    get emailAddresses(): string[];
    set emailAddresses(value: string[]);
    resetEmailAddresses(): void;
    get emailAddressesInput(): string[] | undefined;
}
export interface QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetected {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#email_addresses QualityMonitorPluginframework#email_addresses}
    */
    readonly emailAddresses?: string[];
}
export declare function qualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetectedToTerraform(struct?: QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetected | cdktf.IResolvable): any;
export declare function qualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetectedToHclTerraform(struct?: QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetected | cdktf.IResolvable): any;
export declare class QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetectedOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetected | cdktf.IResolvable | undefined;
    set internalValue(value: QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetected | cdktf.IResolvable | undefined);
    private _emailAddresses?;
    get emailAddresses(): string[];
    set emailAddresses(value: string[]);
    resetEmailAddresses(): void;
    get emailAddressesInput(): string[] | undefined;
}
export interface QualityMonitorPluginframeworkNotifications {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#on_failure QualityMonitorPluginframework#on_failure}
    */
    readonly onFailure?: QualityMonitorPluginframeworkNotificationsOnFailure;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#on_new_classification_tag_detected QualityMonitorPluginframework#on_new_classification_tag_detected}
    */
    readonly onNewClassificationTagDetected?: QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetected;
}
export declare function qualityMonitorPluginframeworkNotificationsToTerraform(struct?: QualityMonitorPluginframeworkNotifications | cdktf.IResolvable): any;
export declare function qualityMonitorPluginframeworkNotificationsToHclTerraform(struct?: QualityMonitorPluginframeworkNotifications | cdktf.IResolvable): any;
export declare class QualityMonitorPluginframeworkNotificationsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): QualityMonitorPluginframeworkNotifications | cdktf.IResolvable | undefined;
    set internalValue(value: QualityMonitorPluginframeworkNotifications | cdktf.IResolvable | undefined);
    private _onFailure;
    get onFailure(): QualityMonitorPluginframeworkNotificationsOnFailureOutputReference;
    putOnFailure(value: QualityMonitorPluginframeworkNotificationsOnFailure): void;
    resetOnFailure(): void;
    get onFailureInput(): cdktf.IResolvable | QualityMonitorPluginframeworkNotificationsOnFailure | undefined;
    private _onNewClassificationTagDetected;
    get onNewClassificationTagDetected(): QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetectedOutputReference;
    putOnNewClassificationTagDetected(value: QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetected): void;
    resetOnNewClassificationTagDetected(): void;
    get onNewClassificationTagDetectedInput(): cdktf.IResolvable | QualityMonitorPluginframeworkNotificationsOnNewClassificationTagDetected | undefined;
}
export interface QualityMonitorPluginframeworkSchedule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#quartz_cron_expression QualityMonitorPluginframework#quartz_cron_expression}
    */
    readonly quartzCronExpression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#timezone_id QualityMonitorPluginframework#timezone_id}
    */
    readonly timezoneId: string;
}
export declare function qualityMonitorPluginframeworkScheduleToTerraform(struct?: QualityMonitorPluginframeworkSchedule | cdktf.IResolvable): any;
export declare function qualityMonitorPluginframeworkScheduleToHclTerraform(struct?: QualityMonitorPluginframeworkSchedule | cdktf.IResolvable): any;
export declare class QualityMonitorPluginframeworkScheduleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): QualityMonitorPluginframeworkSchedule | cdktf.IResolvable | undefined;
    set internalValue(value: QualityMonitorPluginframeworkSchedule | cdktf.IResolvable | undefined);
    get pauseStatus(): string;
    private _quartzCronExpression?;
    get quartzCronExpression(): string;
    set quartzCronExpression(value: string);
    get quartzCronExpressionInput(): string | undefined;
    private _timezoneId?;
    get timezoneId(): string;
    set timezoneId(value: string);
    get timezoneIdInput(): string | undefined;
}
export interface QualityMonitorPluginframeworkSnapshot {
}
export declare function qualityMonitorPluginframeworkSnapshotToTerraform(struct?: QualityMonitorPluginframeworkSnapshot | cdktf.IResolvable): any;
export declare function qualityMonitorPluginframeworkSnapshotToHclTerraform(struct?: QualityMonitorPluginframeworkSnapshot | cdktf.IResolvable): any;
export declare class QualityMonitorPluginframeworkSnapshotOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): QualityMonitorPluginframeworkSnapshot | cdktf.IResolvable | undefined;
    set internalValue(value: QualityMonitorPluginframeworkSnapshot | cdktf.IResolvable | undefined);
}
export interface QualityMonitorPluginframeworkTimeSeries {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#granularities QualityMonitorPluginframework#granularities}
    */
    readonly granularities: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#timestamp_col QualityMonitorPluginframework#timestamp_col}
    */
    readonly timestampCol: string;
}
export declare function qualityMonitorPluginframeworkTimeSeriesToTerraform(struct?: QualityMonitorPluginframeworkTimeSeries | cdktf.IResolvable): any;
export declare function qualityMonitorPluginframeworkTimeSeriesToHclTerraform(struct?: QualityMonitorPluginframeworkTimeSeries | cdktf.IResolvable): any;
export declare class QualityMonitorPluginframeworkTimeSeriesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): QualityMonitorPluginframeworkTimeSeries | cdktf.IResolvable | undefined;
    set internalValue(value: QualityMonitorPluginframeworkTimeSeries | cdktf.IResolvable | undefined);
    private _granularities?;
    get granularities(): string[];
    set granularities(value: string[]);
    get granularitiesInput(): string[] | undefined;
    private _timestampCol?;
    get timestampCol(): string;
    set timestampCol(value: string);
    get timestampColInput(): string | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework databricks_quality_monitor_pluginframework}
*/
export declare class QualityMonitorPluginframework extends cdktf.TerraformResource {
    static readonly tfResourceType = "databricks_quality_monitor_pluginframework";
    /**
    * Generates CDKTF code for importing a QualityMonitorPluginframework resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the QualityMonitorPluginframework to import
    * @param importFromId The id of the existing QualityMonitorPluginframework that should be imported. Refer to the {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the QualityMonitorPluginframework to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/databricks/databricks/1.52.0/docs/resources/quality_monitor_pluginframework databricks_quality_monitor_pluginframework} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options QualityMonitorPluginframeworkConfig
    */
    constructor(scope: Construct, id: string, config: QualityMonitorPluginframeworkConfig);
    private _assetsDir?;
    get assetsDir(): string;
    set assetsDir(value: string);
    get assetsDirInput(): string | undefined;
    private _baselineTableName?;
    get baselineTableName(): string;
    set baselineTableName(value: string);
    resetBaselineTableName(): void;
    get baselineTableNameInput(): string | undefined;
    private _customMetrics;
    get customMetrics(): QualityMonitorPluginframeworkCustomMetricsList;
    putCustomMetrics(value: QualityMonitorPluginframeworkCustomMetrics[] | cdktf.IResolvable): void;
    resetCustomMetrics(): void;
    get customMetricsInput(): cdktf.IResolvable | QualityMonitorPluginframeworkCustomMetrics[] | undefined;
    get dashboardId(): string;
    private _dataClassificationConfig;
    get dataClassificationConfig(): QualityMonitorPluginframeworkDataClassificationConfigOutputReference;
    putDataClassificationConfig(value: QualityMonitorPluginframeworkDataClassificationConfig): void;
    resetDataClassificationConfig(): void;
    get dataClassificationConfigInput(): cdktf.IResolvable | QualityMonitorPluginframeworkDataClassificationConfig | undefined;
    get driftMetricsTableName(): string;
    private _inferenceLog;
    get inferenceLog(): QualityMonitorPluginframeworkInferenceLogOutputReference;
    putInferenceLog(value: QualityMonitorPluginframeworkInferenceLog): void;
    resetInferenceLog(): void;
    get inferenceLogInput(): cdktf.IResolvable | QualityMonitorPluginframeworkInferenceLog | undefined;
    private _latestMonitorFailureMsg?;
    get latestMonitorFailureMsg(): string;
    set latestMonitorFailureMsg(value: string);
    resetLatestMonitorFailureMsg(): void;
    get latestMonitorFailureMsgInput(): string | undefined;
    get monitorVersion(): string;
    private _notifications;
    get notifications(): QualityMonitorPluginframeworkNotificationsOutputReference;
    putNotifications(value: QualityMonitorPluginframeworkNotifications): void;
    resetNotifications(): void;
    get notificationsInput(): cdktf.IResolvable | QualityMonitorPluginframeworkNotifications | undefined;
    private _outputSchemaName?;
    get outputSchemaName(): string;
    set outputSchemaName(value: string);
    get outputSchemaNameInput(): string | undefined;
    get profileMetricsTableName(): string;
    private _schedule;
    get schedule(): QualityMonitorPluginframeworkScheduleOutputReference;
    putSchedule(value: QualityMonitorPluginframeworkSchedule): void;
    resetSchedule(): void;
    get scheduleInput(): cdktf.IResolvable | QualityMonitorPluginframeworkSchedule | undefined;
    private _skipBuiltinDashboard?;
    get skipBuiltinDashboard(): boolean | cdktf.IResolvable;
    set skipBuiltinDashboard(value: boolean | cdktf.IResolvable);
    resetSkipBuiltinDashboard(): void;
    get skipBuiltinDashboardInput(): boolean | cdktf.IResolvable | undefined;
    private _slicingExprs?;
    get slicingExprs(): string[];
    set slicingExprs(value: string[]);
    resetSlicingExprs(): void;
    get slicingExprsInput(): string[] | undefined;
    private _snapshot;
    get snapshot(): QualityMonitorPluginframeworkSnapshotOutputReference;
    putSnapshot(value: QualityMonitorPluginframeworkSnapshot): void;
    resetSnapshot(): void;
    get snapshotInput(): cdktf.IResolvable | QualityMonitorPluginframeworkSnapshot | undefined;
    get status(): string;
    private _tableName?;
    get tableName(): string;
    set tableName(value: string);
    get tableNameInput(): string | undefined;
    private _timeSeries;
    get timeSeries(): QualityMonitorPluginframeworkTimeSeriesOutputReference;
    putTimeSeries(value: QualityMonitorPluginframeworkTimeSeries): void;
    resetTimeSeries(): void;
    get timeSeriesInput(): cdktf.IResolvable | QualityMonitorPluginframeworkTimeSeries | undefined;
    private _warehouseId?;
    get warehouseId(): string;
    set warehouseId(value: string);
    resetWarehouseId(): void;
    get warehouseIdInput(): string | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
